/*
	Leaflet.contextmenu, a context menu for Leaflet.
	(c) 2015, Adam Ratcliffe, GeoSmart Maps Limited
	(c) 2021-2022, Oleg Gunyakov, Maptorium Tile Downloader
	@preserve
*/
(function(t){var e;if(typeof define==="function"&&define.amd){define(["leaflet"],t)}else if(typeof module==="object"&&typeof module.exports==="object"){e=require("leaflet");module.exports=t(e)}else{if(typeof window.L==="undefined"){throw new Error("Leaflet must be loaded first")}t(window.L)}})(function(f){f.Map.mergeOptions({contextmenuItems:[]});f.Map.ContextMenu=f.Handler.extend({_touchstart:f.Browser.msPointer?"MSPointerDown":f.Browser.pointer?"pointerdown":"touchstart",statics:{CLS_CONTAINER:"dropdown-menu",CLS_DISABLED:"disabled",CLS_TOGGLE:"dropdown-toggle arrow-none",CLS_ELEMENT:"dropdown",CLS_INNER:"dropdown-item",CONTAINER:"ul",ELEMENT:"li",INNER:"a",ZINDEX:1e4},initialize:function(t){f.Handler.prototype.initialize.call(this,t);this._items=[];this._idCounter=0;this._visible=false;this._container=this._initContainer(t._container);this._relatedTarget=false;if(t.options.contextmenuWidth){this._container.style.width=t.options.contextmenuWidth+"px"}this._createItems();f.DomEvent.on(this._container,"click",f.DomEvent.stop).on(this._container,"mousedown",f.DomEvent.stop).on(this._container,"dblclick",f.DomEvent.stop).on(this._container,"contextmenu",f.DomEvent.stop)},addHooks:function(){var t=this._map.getContainer();f.DomEvent.on(document,"keydown",this._onKeyDown,this);if(f.Browser.touch){f.DomEvent.on(document,this._touchstart,this._hide,this)}this._map.on({contextmenu:this._show,mousedown:this._hide,zoomstart:this._hide},this)},removeHooks:function(){var t=this._map.getContainer();f.DomEvent.off(t,"mouseleave",this._hide,this).off(document,"keydown",this._onKeyDown,this);if(f.Browser.touch){f.DomEvent.off(document,this._touchstart,this._hide,this)}this._map.off({contextmenu:this._show,mousedown:this._hide,zoomstart:this._hide},this)},showAt:function(t,e){if(t instanceof f.LatLng){t=this._map.latLngToContainerPoint(t)}this._showAtPoint(t,e)},hide:function(){this._hide()},addItem:function(t){return this.insertItem(t)},insertItem:function(t,e){e=e!==undefined?e:this._items.length;var n=this._createItem(this._container,t,e);this._items.push(n);this._sizeChanged=true;this._map.fire("contextmenu.additem",{contextmenu:this,el:n.el,index:e});return n.el},removeItem:function(t){var e=this._container;if(!isNaN(t)){t=e.children[t]}if(t){this._removeItem(f.Util.stamp(t));this._sizeChanged=true;this._map.fire("contextmenu.removeitem",{contextmenu:this,el:t});return t}return null},removeAllItems:function(){var t=this._container.children,e;while(t.length){e=t[0];this._removeItem(f.Util.stamp(e))}return t},hideAllItems:function(){var t,e,n;for(e=0,n=this._items.length;e<n;e++){t=this._items[e];t.el.style.display="none"}},showAllItems:function(){var t,e,n;for(e=0,n=this._items.length;e<n;e++){t=this._items[e];t.el.style.display=""}},setDisabled:function(t,e){var n=this._container,i="dropdown-item";if(!isNaN(t)){t=n.children[t]}if(t&&f.DomUtil.hasClass(t,i)){if(e){f.DomUtil.addClass(t,"disabled");this._map.fire("contextmenu.disableitem",{contextmenu:this,el:t})}else{f.DomUtil.removeClass(t,"disabled");this._map.fire("contextmenu.enableitem",{contextmenu:this,el:t})}}},isVisible:function(){return this._visible},_initContainer:function(t,e=false){var n=f.DomUtil.create(f.Map.ContextMenu.CONTAINER,f.Map.ContextMenu.CLS_CONTAINER,t);n.style.zIndex=f.Map.ContextMenu.ZINDEX;n.style.position="absolute";return n},_createItems:function(t=this._map.options.contextmenuItems,e=this._container){let n,i,o;for(i=0,o=t.length;i<o;i++){this._items.push(this._createItem(e,t[i]))}},_createItem:function(t,e,n){if(e.separator||e==="-"){return this._createSeparator(t,n)}let i=false;if(e.contextmenuItems){i=true}let o=f.Map.ContextMenu.CLS_ELEMENT;let s=e.disabled?o+" "+f.Map.ContextMenu.CLS_DISABLED:o;s=e.class?o+" "+e.class:o;let r=this._insertElementAt(f.Map.ContextMenu.ELEMENT,s,t,n);this._idCounter++;let a=false;if(!i){a=this._createEventHandler(r,e.callback,e.context,e.hideOnSelect,e.data)}let h=this._getIcon(e);let l=this._getIconCls(e);let m=f.DomUtil.create(f.Map.ContextMenu.INNER,f.Map.ContextMenu.CLS_INNER,r);m.href="#";m.setAttribute("role","button");m.setAttribute("data-toggle","dropdown");m.setAttribute("aria-haspopup","true");m.setAttribute("aria-expanded","false");if(l){f.DomUtil.create("i",l,m)}if(h){let t=f.DomUtil.create("img","",m);t.src=h}let u=f.DomUtil.create("span","",m);u.innerHTML="&nbsp;"+e.text;if(i){f.DomUtil.addClass(m,f.Map.ContextMenu.CLS_TOGGLE);if(e.contextmenuItems){let t=this._initContainer(r,true);this._createItems(e.contextmenuItems,t)}}if(!i){f.DomEvent.on(r,"mousedown",f.DomEvent.stopPropagation).on(r,"click",a)}else{f.DomEvent.on(r,"click",this._showSubMenu,this)}if(f.Browser.touch){f.DomEvent.on(r,this._touchstart,f.DomEvent.stopPropagation)}if(!f.Browser.pointer){f.DomEvent.on(r,"click",this._onItemMouseOut,this)}return{id:f.Util.stamp(r),el:r,callback:a}},_showSubMenu:function(t){let e=t.target.closest(".dropdown-menu");let n=e.querySelectorAll(".show");for(o=0;o<n.length;o++){f.DomUtil.removeClass(n[o],"show")}let i=t.target.closest("li");i=i.querySelector(".dropdown-menu");if(i){i.style.top="0px";i.style.left=e.offsetWidth+"px";if(f.DomUtil.hasClass(i,"show")){}else{f.DomUtil.addClass(i,"show")}}},_hideSubMenu:function(t){let e=t.target.closest("li");e=e.querySelector(".dropdown-menu");f.DomUtil.removeClass(e,"show")},_removeItem:function(t){var e,n,i,o,s;for(i=0,o=this._items.length;i<o;i++){e=this._items[i];if(e.id===t){n=e.el;s=e.callback;if(s){f.DomEvent.off(n,"mouseover",this._onItemMouseOver,this).off(n,"mouseover",this._onItemMouseOut,this).off(n,"mousedown",f.DomEvent.stopPropagation).off(n,"click",s);if(f.Browser.touch){f.DomEvent.off(n,this._touchstart,f.DomEvent.stopPropagation)}if(!f.Browser.pointer){f.DomEvent.on(n,"click",this._onItemMouseOut,this)}}this._container.removeChild(n);this._items.splice(i,1);return e}}return null},_createSeparator:function(t,e){var n=this._insertElementAt("div","dropdown-divider",t,e);return{id:f.Util.stamp(n),el:n}},_createEventHandler:function(a,h,l,m,u){var c=this,t=this._map,d="disabled",m=m!==undefined?m:true;return function(t){if(f.DomUtil.hasClass(a,d)){return}var e=c._map,n=c._showLocation.containerPoint,i=e.containerPointToLayerPoint(n),o=e.layerPointToLatLng(i),s=c._relatedTarget,r={containerPoint:n,layerPoint:i,latlng:o,relatedTarget:s,data:u};if(m){c._hide()}if(h){h.call(l||e,r)}c._map.fire("contextmenu.select",{contextmenu:c,el:a})}},_insertElementAt:function(t,e,n,i){var o,s=document.createElement(t);s.className=e;if(i!==undefined){o=n.children[i]}if(o){n.insertBefore(s,o)}else{n.appendChild(s)}return s},_show:function(t){var e=document.querySelectorAll(".show");for(var n=0;n<e.length;n++){f.DomUtil.removeClass(e[n],"show")}this._showAtPoint(t.containerPoint,t)},_showAtPoint:function(t,e){if(this._items.length){var n=this._map,i=f.extend(e||{},{contextmenu:this});this._showLocation={containerPoint:t};if(e&&e.relatedTarget){this._relatedTarget=e.relatedTarget}this._setPosition(t);if(!this._visible){this._container.style.display="block";this._visible=true}this._map.fire("contextmenu.show",i)}},_hide:function(){if(this._visible){this._visible=false;this._container.style.display="none";this._map.fire("contextmenu.hide",{contextmenu:this})}},_getIcon:function(t){return f.Browser.retina&&t.retinaIcon||t.icon},_getIconCls:function(t){return f.Browser.retina&&t.retinaIconCls||t.iconCls},_setPosition:function(t){var e=this._map.getSize(),n=this._container,i=this._getElementSize(n),o;if(this._map.options.contextmenuAnchor){o=f.point(this._map.options.contextmenuAnchor);t=t.add(o)}n._leaflet_pos=t;if(t.x+i.x>e.x){n.style.left="auto";n.style.right=Math.min(Math.max(e.x-t.x,0),e.x-i.x-1)+"px"}else{n.style.left=Math.max(t.x,0)+"px";n.style.right="auto"}if(t.y+i.y>e.y){n.style.top="auto";n.style.bottom=Math.min(Math.max(e.y-t.y,0),e.y-i.y-1)+"px"}else{n.style.top=Math.max(t.y,0)+"px";n.style.bottom="auto"}},_getElementSize:function(t){var e=this._size,n=t.style.display;if(!e||this._sizeChanged){e={};t.style.left="-999999px";t.style.right="auto";t.style.display="block";e.x=t.offsetWidth;e.y=t.offsetHeight;t.style.left="auto";t.style.display=n;this._sizeChanged=false}return e},_onKeyDown:function(t){var e=t.keyCode;if(e===27){this._hide()}},_onItemMouseOver:function(t){},_onItemMouseOut:function(t){}});f.Map.addInitHook("addHandler","contextmenu",f.Map.ContextMenu);f.Mixin.ContextMenu={bindContextMenu:function(t){f.setOptions(this,t);this._initContextMenu();return this},unbindContextMenu:function(){this.off("contextmenu",this._showContextMenu,this);return this},addContextMenuItem:function(t){this.options.contextmenuItems.push(t)},removeContextMenuItemWithIndex:function(t){var e=[];for(var n=0;n<this.options.contextmenuItems.length;n++){if(this.options.contextmenuItems[n].index==t){e.push(n)}}var i=e.pop();while(i!==undefined){this.options.contextmenuItems.splice(i,1);i=e.pop()}},replaceContextMenuItem:function(t){this.removeContextMenuItemWithIndex(t.index);this.addContextMenuItem(t)},_initContextMenu:function(){this._items=[];this.on("contextmenu",this._showContextMenu,this)},_showContextMenu:function(t){var e,n,i,o,s;if(this._map.contextmenu){n=f.extend({relatedTarget:this},t);i=this._map.mouseEventToContainerPoint(t.originalEvent);if(!this.options.contextmenuInheritItems){this._map.contextmenu.hideAllItems()}this._subMenu(this.options.contextmenuItems);this._map.once("contextmenu.hide",this._hideContextMenu,this);var r=document.querySelectorAll(".show");for(var o=0;o<r.length;o++){f.DomUtil.removeClass(r[o],"show")}this._map.contextmenu.showAt(i,n)}},_subMenu:function(t){for(o=0,i=t.length;o<i;o++){itemOptions=t[o];this._items.push(this._map.contextmenu.insertItem(itemOptions,itemOptions.index))}},_hideContextMenu:function(){var t,e;for(t=0,e=this._items.length;t<e;t++){this._map.contextmenu.removeItem(this._items[t])}this._items.length=0;if(!this.options.contextmenuInheritItems){this._map.contextmenu.showAllItems()}}};var t=[f.Marker,f.Path],e={contextmenu:false,contextmenuItems:[],contextmenuInheritItems:true},n,o,i;for(o=0,i=t.length;o<i;o++){n=t[o];if(!n.prototype.options){n.prototype.options=e}else{n.mergeOptions(e)}n.addInitHook(function(){if(this.options.contextmenu){this._initContextMenu()}});n.include(f.Mixin.ContextMenu)}return f.Map.ContextMenu});